diff -Naur LA.AF.1.1.1-03210-8064.0_org/src/utils/common.c LA.AF.1.1.1-03210-8064.0_new/src/utils/common.c
--- LA.AF.1.1.1-03210-8064.0_org/src/utils/common.c	2018-07-26 10:07:18.702051121 +0800
+++ LA.AF.1.1.1-03210-8064.0_new/src/utils/common.c	2019-02-13 15:26:47.375845934 +0800
@@ -593,6 +593,29 @@
 }
 
 
+int has_ctrl_char(const u8 *data, size_t len)
+{
+	size_t i;
+
+	for (i = 0; i < len; i++) {
+		if (data[i] < 32 || data[i] == 127)
+			return 1;
+	}
+	return 0;
+}
+
+
+int has_newline(const char *str)
+{
+	while (*str) {
+		if (*str == '\n' || *str == '\r')
+			return 1;
+		str++;
+	}
+	return 0;
+}
+
+
 size_t merge_byte_arrays(u8 *res, size_t res_len,
 			 const u8 *src1, size_t src1_len,
 			 const u8 *src2, size_t src2_len)
diff -Naur LA.AF.1.1.1-03210-8064.0_org/src/utils/common.h LA.AF.1.1.1-03210-8064.0_new/src/utils/common.h
--- LA.AF.1.1.1-03210-8064.0_org/src/utils/common.h	2018-07-26 10:07:18.702051121 +0800
+++ LA.AF.1.1.1-03210-8064.0_new/src/utils/common.h	2019-02-13 15:26:47.375845934 +0800
@@ -494,6 +494,8 @@
 char * wpa_config_parse_string(const char *value, size_t *len);
 int is_hex(const u8 *data, size_t len);
 int find_first_bit(u32 value);
+int has_ctrl_char(const u8 *data, size_t len);
+int has_newline(const char *str);
 size_t merge_byte_arrays(u8 *res, size_t res_len,
 			 const u8 *src1, size_t src1_len,
 			 const u8 *src2, size_t src2_len);
diff -Naur LA.AF.1.1.1-03210-8064.0_org/src/wps/wps_attr_process.c LA.AF.1.1.1-03210-8064.0_new/src/wps/wps_attr_process.c
--- LA.AF.1.1.1-03210-8064.0_org/src/wps/wps_attr_process.c	2018-07-26 10:07:18.702051121 +0800
+++ LA.AF.1.1.1-03210-8064.0_new/src/wps/wps_attr_process.c	2019-02-13 15:19:38.067835236 +0800
@@ -229,6 +229,16 @@
 		cred->key_len--;
 #endif /* CONFIG_WPS_STRICT */
 	}
+
+
+	if (cred->auth_type & (WPS_AUTH_WPAPSK | WPS_AUTH_WPA2PSK) &&
+	    (cred->key_len < 8 || has_ctrl_char(cred->key, cred->key_len))) {
+		wpa_printf(MSG_INFO, "WPS: Reject credential with invalid WPA/WPA2-Personal passphrase");
+		wpa_hexdump_ascii_key(MSG_INFO, "WPS: Network Key",
+				      cred->key, cred->key_len);
+		return -1;
+	}
+
 	return 0;
 }
 
diff -Naur LA.AF.1.1.1-03210-8064.0_org/wpa_supplicant/config.c LA.AF.1.1.1-03210-8064.0_new/wpa_supplicant/config.c
--- LA.AF.1.1.1-03210-8064.0_org/wpa_supplicant/config.c	2018-07-26 10:07:18.674051120 +0800
+++ LA.AF.1.1.1-03210-8064.0_new/wpa_supplicant/config.c	2019-02-13 15:29:55.619850624 +0800
@@ -318,6 +318,12 @@
 		}
 		wpa_hexdump_ascii_key(MSG_MSGDUMP, "PSK (ASCII passphrase)",
 				      (u8 *) value, len);
+		if (has_ctrl_char((u8 *) value, len)) {
+			wpa_printf(MSG_ERROR,
+				   "Line %d: Invalid passphrase character",
+				   line);
+			return -1;
+		}
 		if (ssid->passphrase && os_strlen(ssid->passphrase) == len &&
 		    os_memcmp(ssid->passphrase, value, len) == 0)
 			return 0;
@@ -2367,8 +2373,19 @@
 
 	for (i = 0; i < NUM_SSID_FIELDS; i++) {
 		const struct parse_data *field = &ssid_fields[i];
-		if (os_strcmp(var, field->name) == 0)
-			return field->writer(field, ssid);
+		if (os_strcmp(var, field->name) == 0) {
+			char *ret = field->writer(field, ssid);
+
+			if (ret && has_newline(ret)) {
+				wpa_printf(MSG_ERROR,
+					   "Found newline in value for %s; not returning it",
+					   var);
+				os_free(ret);
+				ret = NULL;
+			}
+
+			return ret;
+		}
 	}
 
 	return NULL;
@@ -2553,6 +2570,8 @@
 
 	if (os_strcmp(var, "password") == 0 &&
 	    os_strncmp(value, "ext:", 4) == 0) {
+		if (has_newline(value))
+			return -1;
 		str_clear_free(cred->password);
 		cred->password = os_strdup(value);
 		cred->ext_password = 1;
@@ -2603,9 +2622,14 @@
 	}
 
 	val = wpa_config_parse_string(value, &len);
-	if (val == NULL) {
+	if (val == NULL ||
+	    (os_strcmp(var, "excluded_ssid") != 0 &&
+	     os_strcmp(var, "roaming_consortium") != 0 &&
+	     os_strcmp(var, "required_roaming_consortium") != 0 &&
+	     has_newline(val))) {
 		wpa_printf(MSG_ERROR, "Line %d: invalid field '%s' string "
 			   "value '%s'.", line, var, value);
+		os_free(val);
 		return -1;
 	}
 
@@ -3392,6 +3416,12 @@
 		return -1;
 	}
 
+	if (has_newline(pos)) {
+		wpa_printf(MSG_ERROR, "Line %d: invalid %s value with newline",
+			   line, data->name);
+		return -1;
+	}
+
 	tmp = os_strdup(pos);
 	if (tmp == NULL)
 		return -1;